/* ----------------------------------------------------------------------------
 * global variables
 * ---------------------------------------------------------------------------- */
var ns4                    = false;
var ie4                    = false;
var pre                    = '';
var post                   = '';
var post2                  = '';
var sldEntries             = new Array();
var tpEntries              = new Array();
var slides                 = new Array();
var thumbTimestamps        = new Array();
var offset                 = null;
var actualTimestamp        = 0;
var lastTimestamp          = 0;
var timerID                = null;
var slideIndex             = 0;
var oldSlideIndex          = 0;
var oldTimestamp           = 0;
var curSlideIndex          = 0;
var curPointerIndex        = 0;
var MediaPlayer1           = null;
var StatusBar              = null;
var ControlPanel           = null;
var RealplayerStl          = null;
var RealcontrolStl         = null;
var RealstatusStl          = null;
var TelepointerStl         = null;
var TelepointerImg         = null;
var Tablevideo             = null;
var Tableslide             = null;
var TablemetadataStl       = null;
var VideoviewStl           = null;
var SlideviewStl           = null;
var Stillimage             = null;
var StillimageStl          = null;
var StillimageImg          = null;
var StillimageWidth        = 0;
var StillimageHeight       = 0;
var Slideareas             = new Array();
var SlideareasStl          = new Array();
var SlideareasImg          = new Array();
var slideareaTop           = 0;
var videoframeWidth        = 0;
var videoframeHeight       = 0;
var viewframeWidth         = 0;
var viewframeHeight        = 0;
var allframesWidth         = 0;
var allframesHeight        = 0;
var aspectRatioVideo       = 0.0;
var aspectRatioSlide       = 0.0;
var oldSlidesTop           = new Array();
var oldSlidesLeft          = new Array();
var oldSlidesWidth         = new Array();
var oldSlidesHeight        = new Array();
var oldTpWidth             = 0;
var scaleSlide             = 1.0;
var screenWidth            = 0;
var screenHeight           = 0;
var TYPE_NOVIDEO           = 0;
var TYPE_VIDEO             = 1;
var TYPE_STILLIMAGE        = 2;
var videoType              = TYPE_VIDEO;
var videoWidth             = 320;
var videoHeight            = 240;
var numOfThumbnails        = 9;
var numOfClips             = 0;
var thumbIndex             = 0;
var oldThumbIndex          = 0;
var maxLayerIndex          = 0;
var isScalable             = true;
var tryouts                = 0;
var hasMetadataTable       = false;

/* ----------------------------------------------------------------------------
 * Init
 * ---------------------------------------------------------------------------- */
function init()
{
  determineBrowser();
  initThumbTimestamps();
  initSldEntries();
  initTpEntries();
  initSlides();
  loadAllSlides();

  // We need to wait for the other frames to finish loading  
  delayedInit();
}

function delayedInit()
{
  if( (!top.viewframe.document) ||
      (ie4 && !top.viewframe.document.all.telepointer) ||
      (ns4 && !top.viewframe.document.telepointer) || 
      (!top.indexframe.document) 
    )
  {
    setTimeout("delayedInit()", 100);
  }
  else 
  {
    var bPlayerReady = mediaPlayersLoaded();
    if (!bPlayerReady && tryouts < 45)
    {
      tryouts++;
      setTimeout("delayedInit()", 100);
    }
    else if (tryouts == 45)
    {
      var messageText = "Die Media-Player konnten nicht initialisiert werden. ";
      alert(messageText);
    }
    else
    {
      // normal case
      determineMediaPlayers();
      determineDocumentObjects();
      getAspectRatios();
      loadSlide(0);
      activateSegment(0);
      getRealMediaPosition();
    }
  }
}

/* ----------------------------------------------------------------------------
 * Determine the browser, MediaPlayer and other document objects
 * ---------------------------------------------------------------------------- */
function determineBrowser()
{
  // Netscape 4.x
  if (document.layers)
  {
    ns4   = true;
    ie4   = false;
    pre   = 'document.';
    post  = '';
    post2 = '';
  }

  // Internet Explorer 4.x or higher
  if (document.all)
  {
    ns4   = false;
    ie4   = true;
    pre   = 'document.all.';
    post  = '.style';
    post2 = '';
  }

  // Netscape 6.x ?
  var ns6 = false;
  var ua = navigator.userAgent.toLowerCase();
  var netscapebrowser = ( (ua.indexOf("mozilla") != -1) 
                       && (ua.indexOf("compatible") == -1) 
                       && (ua.indexOf("opera") == -1) );
  var av = navigator.appVersion;
  var version = av.substring(0, av.indexOf(" ")) *1;
  var version2 = av.substring(0, av.indexOf(".")) *1;
  if ( netscapebrowser && (version2 == 5) )
    ns6 = true;

  if (ns6)
    alert("Netscape 6 (und hher) wird leider nicht untersttzt. Um die volle Funktionalitt nutzen zu knnen, benutzen Sie bitte Netscape Version 4.xx oder Internet Explorer ab Version 4.");
  if (!ns4 && !ie4  && !ns6)
    alert("Um die volle Funktionalitt nutzen zu knnen, benutzen Sie bitte Netscape Version 4.xx oder Internet Explorer ab Version 4.");
}

function mediaPlayersLoaded()
{
   if (ie4)
   {
      if (numOfClips > 0)
      {
         return eval('top.viewframe.document.all.tags("embed")[' + (numOfClips-1) + ']') != null;
      }
      else
      {
         return eval('top.videoframe.document.all.tags("embed")[0]') != null;
      }
   }
   else if (ns4)
   {
      if (numOfClips > 0)
      {
         return eval('top.viewframe.document.layers["cliplayer' + (numOfClips-1) + '"].document.embeds["MediaPlayer1"]') != null;
      }
      else
      {
         return eval('top.videoframe.document.layers["realplayer1"].document.embeds["MediaPlayer1"]') != null;
      }
   }
}


function determineMediaPlayers()
{
  if (ie4)
  {
    MediaPlayer1 = top.videoframe.document.all.tags("embed")[0];
    StatusBar    = top.videoframe.document.all.tags("embed")[1];
    ControlPanel = top.videoframe.document.all.tags("embed")[2];
  }
  else if (ns4)
  {
    MediaPlayer1 = top.videoframe.document.layers["realplayer1"].document.embeds["MediaPlayer1"];
    StatusBar    = top.videoframe.document.layers["statusbar"].document.embeds["MediaPlayer1"];
    ControlPanel = top.videoframe.document.layers["controlpanel"].document.embeds["MediaPlayer1"];
  }
  else
  {
  }
}

function determineDocumentObjects()
{
  // Determine Telepointer, Slidearea, etc
  TelepointerStl = eval('top.viewframe.' + pre + 'telepointer' + post);
  RealplayerStl = eval('top.videoframe.' + pre + 'realplayer1' + post);
  RealstatusStl = eval('top.videoframe.' + pre + 'statusbar' + post);
  RealcontrolStl = eval('top.videoframe.' + pre + 'controlpanel' + post);
  SlideviewStl = eval('top.viewframe.' + pre + 'tableslideview' + post);
  if ( (videoType == TYPE_NOVIDEO) || (videoType == TYPE_STILLIMAGE) )
    StillimageStl = eval('top.videoframe.' + pre + 'stillimage' + post);
  if ( (videoType == TYPE_NOVIDEO) 
    || (videoType == TYPE_VIDEO) && (hasMetadataTable) )
    TablemetadataStl = eval('top.videoframe.' + pre + 'tablemetadata' + post);

  Tableslide = eval('top.viewframe.' + pre + 'tableslideview' + post2);
  TelepointerImg = eval('top.viewframe.' + pre + 'telepointer' + post2 + '.document.telepointer24');
  if ( (videoType == TYPE_NOVIDEO) || (videoType == TYPE_STILLIMAGE) )
  {
    Stillimage = eval('top.videoframe.' + pre + 'stillimage' + post2);
    StillimageImg = Stillimage.document.stillimage1;
  }

  for (i = 0; i <= maxLayerIndex; i++)
  {
    SlideareasStl[i] = eval('top.viewframe.' + pre + 'slidearea' + i + post);
    Slideareas[i] = eval('top.viewframe.' + pre + 'slidearea' + i + post2);
    SlideareasImg[i] = eval('Slideareas[' + i + '].document.slidefield' + i);
  }

  oldTpWidth = TelepointerImg.width;

}

/* ----------------------------------------------------------------------------
 * Functions for new URLs
 * ---------------------------------------------------------------------------- */
function gotoImc()
{
  F1 = window.open("http://www.im-c.de","imc_AG");
}

function gotoLecturnity()
{
  F1 = window.open("http://www.lecturnity.de","Lecturnity");
}

/* ----------------------------------------------------------------------------
 * Functions for slides
 * ---------------------------------------------------------------------------- */
function initSlides()
{
  for(i = 0; i < sldEntries.length; i++)
    slides[i] = new Image();
}

function loadAllSlides()
{
  for(i = 0; i < sldEntries.length; i++)
    slides[i].src = sldEntries[i].url;
}

function previousSlide()
{
  var newSlidePosition = slideIndex - 1;
  if (newSlidePosition < 0)
    newSlidePosition = numOfThumbnails;

  var newTarget = 0;
  for(i = 0; i < n; i++)
  {
    newTarget = i;
    if (sldEntries[i].slideNumber == newSlidePosition)
      break;
  }
  showSlide(newTarget);
}

function nextSlide()
{
  var newSlidePosition = slideIndex + 1;
  if (newSlidePosition > numOfThumbnails)
    newSlidePosition = 0;

  var newTarget = 0;
  for(i = 0; i < n; i++)
  {
    newTarget = i;
    if (sldEntries[i].slideNumber == newSlidePosition)
      break;
  }
  showSlide(newTarget);
}

function gotoSlide(position)
{
  var newSlidePosition = position;
  
  if (newSlidePosition > numOfThumbnails)
    newSlidePosition = 0;
  if (newSlidePosition < 0)
    newSlidePosition = numOfThumbnails;

  var newTarget = 0;
  for(i = 0; i < n; i++)
  {
    newTarget = i;
    if (sldEntries[i].slideNumber == newSlidePosition)
      break;
  }
  showSlide(newTarget);
}

function showSlide(position)
{
  loadSlide(position);
  offset = sldEntries[position].slideTime;
  fastForward();
}

function loadSlide(position)
{
  // Hide the Telepointer
  TelepointerStl.visibility = "hidden";

  oldSlideIndex = slideIndex;
  slideIndex = position;
  
  if (slides[position].src == "")
    slides[position].src = sldEntries[position].url;
 
  var layerIndex = sldEntries[position].layerIndex;
  // Layer index 0 ==> full slide
  if (layerIndex == 0)
  {
    // Clear all slide layers
    for (i = 1; i <= maxLayerIndex; i++)
    {
      SlideareasStl[i].visibility = "hidden";
    }

    SlideareasImg[0].src = slides[position].src;
  }
  else
  {
    var sldNumber  = sldEntries[position].slideNumber;
    for (i = 0; i < sldEntries.length; i++)
    {
      if (sldEntries[i].layerIndex > 0)
      {
        if (sldEntries[i].slideNumber == sldNumber)
        {
          if (sldEntries[i].slideTime <= actualTimestamp)
          {
            SlideareasStl[sldEntries[i].layerIndex].visibility = "visible";
          }
          else
          {
            SlideareasStl[sldEntries[i].layerIndex].visibility = "hidden";
          }
        }
        else
        {
          SlideareasStl[sldEntries[i].layerIndex].visibility = "hidden";
        }
      }
      else
      {
        if (sldEntries[i].slideNumber == sldNumber)
        {
          SlideareasImg[0].src = slides[i].src;
        }
      }
    }  
  }
}

/* ----------------------------------------------------------------------------
 * Player Control functions: play, stop, pause, seek
 * (independent from browser; change of layer)
 * ---------------------------------------------------------------------------- */
function play()
{
  playerControlPlay();
}

function stop()
{
  loadSlide(0);
  playerControlStop();
}

function pause()
{
  playerControlPause();
}

function seekTime(timestamp)
{
  var actualTime = new Date();
  var newTimestamp = actualTime.getTime();
  var deltaTimestamp = newTimestamp - oldTimestamp;
  if (deltaTimestamp > 1000)
  {
    oldTimestamp = newTimestamp;
    playerControlSeekTime(timestamp);
  }
  else
  {
    oldTimestamp = newTimestamp;
    // do nothing else
  }
}

/* ----------------------------------------------------------------------------
 * Player Control functions: play, stop, pause (seek => see below)
 * (for Netscape and Internet Explorer)
 * ---------------------------------------------------------------------------- */
function playerControlPlay()
{
  MediaPlayer1.Play();
}

function playerControlStop()
{
  MediaPlayer1.Stop();
}

function playerControlPause()
{
  MediaPlayer1.Pause();
}

/* ----------------------------------------------------------------------------
 * Seek funktions
 * ---------------------------------------------------------------------------- */
function playerControlSeekTime(timestamp)
{
  offset = timestamp;
   
  if (MediaPlayer1.CanPlay())
    MediaPlayer1.DoPlay();
  
  timerID = setInterval("fastForward()", 1000);
}

function fastForward()
{
  if (offset > 0)
    MediaPlayer1.SetPosition(Math.round(offset));
  else
    MediaPlayer1.SetPosition(0);
  
  if ( (MediaPlayer1.GetPlayState() == 5)   /*Seeking*/
    || (MediaPlayer1.GetPlayState() == 3)   /*Playing*/
    || (MediaPlayer1.GetPlayState() == 2) ) /*Buffering*/
  {
    clearInterval(timerID);
    timerID = null;
    offset = null;
  }
}  
  
/* ----------------------------------------------------------------------------
 * Get the Position of the RealMedia Player
 * and related functions
 * ---------------------------------------------------------------------------- */
function getRealMediaPosition()
{
  // Check Frames first
  checkFrameSize();

  if (MediaPlayer1.GetPlayState() != 0)
    actualTimestamp = MediaPlayer1.GetPosition();
  else
    actualTimestamp = offset;

  //if (actualTimestamp < lastTimestamp)
    resetCurrentIndices();

  lastTimestamp = actualTimestamp;
  
  setThumbnail(actualTimestamp);
  setSlide(actualTimestamp);
  setTP(actualTimestamp);
  
  window.setTimeout("getRealMediaPosition()", 20);
}

function setThumbnail(msTime)
{
  var n = numOfThumbnails - 1;
  for (i = 0; i < n; i++)
  {
    if ((msTime >= thumbTimestamps[i]) && (msTime < thumbTimestamps[i+1]))
    {
      if (i != thumbIndex)
      {
        activateSegment(i);
        setAnchor(i);
        setFormSelect(i);
        break;
      }
    }
  }

  if (msTime >= thumbTimestamps[n])
  {
    if (n != thumbIndex)
    {
        activateSegment(n);
        setAnchor(n);
        setFormSelect(n);
    }
  }
}

function setSlide(msTime)
{
  var n = sldEntries.length - 1;
  for (i = curSlideIndex; i < n; i++)
  {
    if ((msTime >= sldEntries[i].slideTime) && (msTime < sldEntries[i+1].slideTime))
    {
      if (i != slideIndex)
      {
        loadSlide(i);
        curSlideIndex = i;
        break;
      }
    }
  }

  if (msTime >= sldEntries[n].slideTime)
  {
    if (n != slideIndex)
    {
      loadSlide(n);
      curSlideIndex = n;
    }
  }
}

function setAnchor(position)
{
  var slideNumberLeft = position - 1;
  if (slideNumberLeft < 0)
    slideNumberLeft = 0;
  var slideNumberRight = position + 2;
  if (slideNumberRight > numOfThumbnails)
    slideNumberRight = numOfThumbnails;

  var reference = "01_informationspaedagogik_indexframe.html#slide";

  var reference1 = reference + slideNumberLeft;
  var reference2 = reference + slideNumberRight;

  if (slideIndex < oldSlideIndex)
    top.indexframe.location.href = reference1;
  else
    top.indexframe.location.href = reference2;

  if (!ie4)
    top.indexframe.location.href = reference1;
}

function setFormSelect(position)
{
  if (ie4) // Internet Explorer
  {
    top.headerframe.form1.select1.selectedIndex = position;
  }
  else if (ns4) // Netscape
  {
    top.headerframe.document.listbox.document.forms["form1"].select1.selectedIndex = position;
  }
}

function setTP(msTime)
{
  var n = tpEntries.length - 1;
  for (i = curPointerIndex; i < n; i++)
  {
    if ((msTime >= tpEntries[i].tpTime) && (msTime < tpEntries[i+1].tpTime))
    {
     	showTP(i);
     	curPointerIndex = i;
     	break;
    }
  }

  if (msTime >= tpEntries[n].tpTime)
  {
    showTP(n);
    curPointerIndex = n;
  }
}

function showTP(idx)
{
  if (tpEntries[idx].isVisible == true)
  {
    TelepointerStl.top = tpEntries[idx].y * scaleSlide  + slideareaTop 
                         - (0.5 * oldTpWidth * (1 - scaleSlide));
    TelepointerStl.left = tpEntries[idx].x * scaleSlide + 20;
    TelepointerStl.visibility = "visible";
  }
  else
    TelepointerStl.visibility = "hidden";
}

function resetCurrentIndices()
{
  curSlideIndex = 0;
  curPointerIndex = 0;
}

/* ----------------------------------------------------------------------------
 * Highlight the actual thumbnail
 * ---------------------------------------------------------------------------- */
function activateSegment(segmentID)
{
  oldThumbIndex = thumbIndex;
  thumbIndex = segmentID;
  
  var numOfLayers = 2 * numOfThumbnails;
  
  if (ie4 && top.indexframe.document) // Internet Explorer
  {
    if (top.indexframe.document.all.tags("div").length == numOfLayers)
    {
      eval("top.indexframe.document.all.tags(\"div\")[\"slide" + oldThumbIndex + "\"].style.backgroundColor='#FFFFFF'");
      eval("top.indexframe.document.all.tags(\"div\")[\"slide" + thumbIndex + "\"].style.backgroundColor='#FFAA7B'");
      eval("top.indexframe.document.all.tags(\"div\")[\"slide" + oldThumbIndex + "a\"].style.backgroundColor='#FFFFFF'");
      eval("top.indexframe.document.all.tags(\"div\")[\"slide" + thumbIndex + "a\"].style.backgroundColor='#FFAA7B'");
    }
  }
  else if (ns4 && top.indexframe.document) // Netscape
  {
    if (top.indexframe.document.layers.length == numOfLayers)
    {
      top.indexframe.document.layers[thumbIndex].clip.width = 101;
      eval("top.indexframe.document.slide" + oldThumbIndex + ".bgColor='#FFFFFF'");
      eval("top.indexframe.document.slide" + thumbIndex + ".bgColor='#FFAA7B'");
      eval("top.indexframe.document.slide" + oldThumbIndex + "a.bgColor='#FFFFFF'");
      eval("top.indexframe.document.slide" + thumbIndex + "a.bgColor='#FFAA7B'");
    }
  }
}

/* ----------------------------------------------------------------------------
 * Part for Dynamic Frames
 * ---------------------------------------------------------------------------- */
function getAspectRatios()
{
  // Get the video size
  var playerWidth = 0;
  var playerHeight = 0;

  if ( (videoType == TYPE_NOVIDEO) || (videoType == TYPE_STILLIMAGE) )
  {
    playerWidth =  StillimageImg.width;
    playerHeight =  StillimageImg.height;
    StillimageWidth = playerWidth;
    StillimageHeight = playerHeight;
  }
  else
  {
    if (ns4) // Netscape 4.x
    {
      // Use default values; width and height can not be changed dynamically
      playerWidth = videoWidth;
      playerHeight = videoHeight;
    }
    else
    {
      playerWidth =  MediaPlayer1.width;
      playerHeight =  MediaPlayer1.height;
    }
  }
  aspectRatioVideo = (playerHeight > 1) ? (playerWidth / playerHeight) : 0;
  
  // Get the slides position & size
  for (i = 0; i <= maxLayerIndex; i++)
  {
    var idx = 0;
    for(k = 0; k < sldEntries.length; k++)
    {
      idx = k;
      if (sldEntries[k].layerIndex == i)
        break;
    }
    
    SlideareasStl[i].top  = sldEntries[idx].y + 24;
    SlideareasStl[i].left = sldEntries[idx].x + 20;
    oldSlidesTop[i]       = sldEntries[idx].y;
    oldSlidesLeft[i]      = sldEntries[idx].x;
    oldSlidesWidth[i]     = sldEntries[idx].width;
    oldSlidesHeight[i]    = sldEntries[idx].height;
  }
  slideareaTop = parseInt(SlideareasStl[0].top);

  aspectRatioSlide = (oldSlidesHeight[0] > 0) ? (oldSlidesWidth[0] / oldSlidesHeight[0]) : (videoWidth / videoHeight);

  // Get the screen size
  screenWidth = screen.width;
  screenHeight = screen.height;
}

function checkFrameSize()
{
  var videoframeHasChanged = false;
  var viewframeHasChanged = false;
  var allframesHaveChanged = false;

  var videoframeW = 0;
  var videoframeH = 0;
  var viewframeW  = 0;
  var viewframeH  = 0;
  var allframesW  = 0;
  var allframesH  = 0;

  if (ie4) // Internet Explorer
  {
    videoframeW = top.videoframe.document.body.offsetWidth;
    videoframeH = top.videoframe.document.body.offsetHeight;
    viewframeW  = top.viewframe.document.body.offsetWidth;
    viewframeH  = top.viewframe.document.body.offsetHeight;
    allframesW  = top.document.body.offsetWidth;
    allframesH  = top.document.body.offsetHeight;
  }
  else if (ns4) // Netscape
  {
    videoframeW = top.videoframe.window.innerWidth;
    videoframeH = top.videoframe.window.innerHeight;
    viewframeW  = top.viewframe.window.innerWidth;
    viewframeH  = top.viewframe.window.innerHeight;
    allframesW  = top.window.innerWidth;
    allframesH  = top.window.innerWidth;
  }
  
  if (videoframeWidth != videoframeW)
  {
    videoframeWidth = videoframeW;
    videoframeHasChanged = true;
  }
  if (videoframeHeight != videoframeH)
  {
    videoframeHeight = videoframeH;
    videoframeHasChanged = true;
  }
  if (viewframeWidth != viewframeW)
  {
    viewframeWidth = viewframeW;
    viewframeHasChanged = true;
  }
  if (viewframeHeight != viewframeH)
  {
    viewframeHeight = viewframeH;
    viewframeHasChanged = true;
  }
  if (allframesWidth != allframesW)
  {
    allframesWidth = allframesW;
    allframesHaveChanged = true;
  }
  if (allframesHeight != allframesH)
  {
    allframesHeight = allframesH;
    allframesHaveChanged = true;
  }
  
  if (videoframeHasChanged)
  {
    resizeRealPlayer(videoframeWidth, videoframeHeight);
  }
  if (viewframeHasChanged)
  {
    resizeSlides(viewframeWidth, viewframeHeight);
  }
  if (allframesHaveChanged)
  {
    // do nothing
  }
}

function resizeRealPlayer(frameWidth, frameHeight)
{
  if (frameWidth < 120)
    return;
  if (frameHeight < 140)
    return;
  
  var maxPlayerWidth = frameWidth - 40;
  var maxPlayerHeight = frameHeight - 82;
  var tempPlayerHeight = (aspectRatioVideo > 0) ? (maxPlayerWidth / aspectRatioVideo) : 1;

  // Netscape 4.x: width and height can not be changed dynamically
  if ((!ns4) && (isScalable == true))
  {
    if (tempPlayerHeight > maxPlayerHeight)
    {
      if ( (videoType == TYPE_NOVIDEO) || (videoType == TYPE_STILLIMAGE) )
      {
        MediaPlayer1.height = 1;
        MediaPlayer1.width = (maxPlayerHeight * aspectRatioVideo);
        if (Tablevideo != null)
          Tablevideo.document.headline.width = (maxPlayerHeight * aspectRatioVideo);
      }
      else
      {
        MediaPlayer1.height = maxPlayerHeight;
        MediaPlayer1.width = (MediaPlayer1.height * aspectRatioVideo);
        if (Tablevideo != null)
          Tablevideo.document.headline.width = (MediaPlayer1.height * aspectRatioVideo);
      }
    }
    else
    {
      MediaPlayer1.width = maxPlayerWidth;
      if ( (videoType == TYPE_NOVIDEO) || (videoType == TYPE_STILLIMAGE) )
        MediaPlayer1.height = 1;
      else
        MediaPlayer1.height = (aspectRatioVideo > 0) ? (MediaPlayer1.width / aspectRatioVideo) : 1;
      if (Tablevideo != null)
        Tablevideo.document.headline.width = maxPlayerWidth;
    }
    RealplayerStl.top = frameHeight - MediaPlayer1.height - 70;
    RealcontrolStl.top = frameHeight - 70;
    RealstatusStl.top = frameHeight - 40;
      
    if ( (videoType == TYPE_NOVIDEO) || (videoType == TYPE_STILLIMAGE) )
    {
      var availableWidth = frameWidth - 40;
      var availableHeight = frameHeight - 80;
      var scale = Math.min(availableWidth/StillimageWidth, availableHeight/StillimageHeight);
      if (scale > 1.0)
         scale = 1.0;
      StillimageImg.width = scale*StillimageWidth;
      StillimageImg.height = scale*StillimageHeight;
      if (videoType == TYPE_STILLIMAGE)
      {
        var stillimageOffsetHeight = scale * (120 + (0.5 * StillimageHeight));
        StillimageStl.top = frameHeight - stillimageOffsetHeight - 70;
      }
      else
      {
        StillimageStl.top = frameHeight - StillimageImg.height - 70;
      }
      StillimageStl.left = 20+(MediaPlayer1.width - StillimageImg.width)/2;
    }
    
    if ( (videoType == TYPE_NOVIDEO) 
      || (videoType == TYPE_VIDEO) && (hasMetadataTable) )
      TablemetadataStl.top = frameHeight - 105;
    
    // Resize status bar and control panel
    StatusBar.width = MediaPlayer1.width;
    ControlPanel.width = MediaPlayer1.width;
  }
}

function resizeSlides(frameWidth, frameHeight)
{
  if (frameWidth < 100)
    return;
  if (frameHeight < 40)
    return;
  
  var maxSlideWidth = frameWidth - 40;
  var maxSlideHeight = frameHeight - 37;
  var tempSlideHeight = (maxSlideWidth / aspectRatioSlide);

  // Netscape 4.x: width and height can not be changed dynamically
  if ((!ns4) && (isScalable == true))
  {
    if (tempSlideHeight > maxSlideHeight)
    {
      scaleSlide = maxSlideHeight / oldSlidesHeight[0];
    }
    else
    {
      scaleSlide = maxSlideWidth / oldSlidesWidth[0];
    }

    if ((scaleSlide > 0.95) && (scaleSlide < 1.05))
      scaleSlide = 1.0;
          
    SlideareasStl[0].top    = parseInt(oldSlidesTop[0] * scaleSlide + 0.5) + parseInt(SlideareasStl[0].top);
    SlideareasStl[0].left   = parseInt(oldSlidesLeft[0] * scaleSlide + 0.5) + parseInt(SlideareasStl[0].left);
    SlideareasImg[0].width  = parseInt(oldSlidesWidth[0] * scaleSlide + 0.5) + 2;
    SlideareasImg[0].height = parseInt(oldSlidesHeight[0] * scaleSlide + 0.5) + 2;
    SlideareasStl[0].top    = parseInt(0.5 * (frameHeight - SlideareasImg[0].height)) + 11;
    SlideviewStl.top        = parseInt(0.5 * (frameHeight - SlideareasImg[0].height)) - 8;
  
    for (i = 1; i <= maxLayerIndex; i++)
    {
      SlideareasStl[i].top    = parseInt(oldSlidesTop[i] * scaleSlide + 0.5) + parseInt(SlideareasStl[0].top);
      SlideareasStl[i].left   = parseInt(oldSlidesLeft[i] * scaleSlide + 0.5) + parseInt(SlideareasStl[0].left);
      SlideareasImg[i].width  = parseInt(oldSlidesWidth[i] * scaleSlide + 0.5);
      SlideareasImg[i].height = parseInt(oldSlidesHeight[i] * scaleSlide + 0.5);
    }
    Tableslide.document.headline.width = SlideareasImg[0].width;
  
    slideareaTop = parseInt(SlideareasStl[0].top);
  
    // Resize Telepointer
    TelepointerImg.width = parseInt(oldTpWidth * scaleSlide + 0.5);
    TelepointerImg.height = parseInt(oldTpWidth * scaleSlide + 0.5); 
  }
}

function videoDblClick()
{
  // do nothing
}

function slideDblClick()
{
  // do nothing
}

function closePopups()
{
  // do nothing
}

/* ----------------------------------------------------------------------------
 * Get the Timestamps of the Thumbnails
 * ---------------------------------------------------------------------------- */
function initThumbTimestamps()
{
  thumbTimestamps[0] = 0;
  thumbTimestamps[1] = 5853;
  thumbTimestamps[2] = 1041641;
  thumbTimestamps[3] = 1044941;
  thumbTimestamps[4] = 1053571;
  thumbTimestamps[5] = 1103164;
  thumbTimestamps[6] = 1136156;
  thumbTimestamps[7] = 1222524;
  thumbTimestamps[8] = 1249837;
}

/* ----------------------------------------------------------------------------
 * The "sldEntry" object
 * ---------------------------------------------------------------------------- */
function sldEntry(slideNumber, slideTime, url, 
                  layerIndex, x, y, width, height)
{
  this.slideNumber = slideNumber;
  this.slideTime = slideTime;
  this.url = url;
  this.layerIndex = layerIndex;
  this.x = x;
  this.y = y;
  this.width = width;
  this.height = height;
}

/* ----------------------------------------------------------------------------
 * Create instances of the "sldEntry" object
 * ---------------------------------------------------------------------------- */
function initSldEntries()
{
  sldEntries[0] = new sldEntry(0, 0, "01_informationspaedagogik_00000000.png", 0, 0, 0, 528, 396);
  sldEntries[1] = new sldEntry(1, 5853, "01_informationspaedagogik_00005853.png", 0, 0, 0, 528, 396);
  sldEntries[2] = new sldEntry(2, 1041641, "01_informationspaedagogik_01041641.png", 0, 0, 0, 528, 396);
  sldEntries[3] = new sldEntry(3, 1044941, "01_informationspaedagogik_01044941.png", 0, 0, 0, 528, 396);
  sldEntries[4] = new sldEntry(4, 1053571, "01_informationspaedagogik_01053571.png", 0, 0, 0, 528, 396);
  sldEntries[5] = new sldEntry(5, 1103164, "01_informationspaedagogik_01103164.png", 0, 0, 0, 528, 396);
  sldEntries[6] = new sldEntry(6, 1136156, "01_informationspaedagogik_01136156.png", 0, 0, 0, 528, 396);
  sldEntries[7] = new sldEntry(7, 1222524, "01_informationspaedagogik_01222524.png", 0, 0, 0, 528, 396);
  sldEntries[8] = new sldEntry(8, 1249837, "01_informationspaedagogik_01249837.png", 0, 0, 0, 528, 396);
}

/* ----------------------------------------------------------------------------
 * The "tpEntry" object
 * ---------------------------------------------------------------------------- */
function tpEntry(tpTime, x, y, isVisible)
{
  this.tpTime = tpTime;
  this.x = x;
  this.y = y;
  this.isVisible = isVisible;
}

/* ----------------------------------------------------------------------------
 * Create instances of the "tpEntry" object
 * ---------------------------------------------------------------------------- */
function initTpEntries()
{
  tpEntries[0] = new tpEntry(0, -1, -1, false);
}
